/*****************************************************************************/
/*  MXAPI.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                          */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Defines to acces the Matrix API in C#                                    */
/*****************************************************************************/

namespace MXAPI
{
    using System;
    using System.Runtime.InteropServices;   /* Required namespace for the DllImport method */
    using System.Text;

	public class Matrix
	{
		/* This c#-class will import the Matrix API classes */	
		
		[DllImport("MATRIX32.DLL", EntryPoint="Init_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Init_MatrixAPI();

		[DllImport("MATRIX32.DLL", EntryPoint="Release_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Release_MatrixAPI();

		[DllImport("MATRIX32.DLL", EntryPoint="GetVersionAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionAPI();

		[DllImport("MATRIX32.DLL", EntryPoint="GetVersionDRV", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV();

		[DllImport("MATRIX32.DLL", EntryPoint="GetVersionDRV_USB", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV_USB();

		[DllImport("MATRIX32.DLL", EntryPoint="GetVersionDRV_USB", CallingConvention = CallingConvention.StdCall)]
		public static extern void SetW95Access(short Mode);

		[DllImport("MATRIX32.DLL", EntryPoint="GetPortAdr", CallingConvention = CallingConvention.StdCall)]
		public static extern short GetPortAdr(short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="PausePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short PausePrinterActivity();

		[DllImport("MATRIX32.DLL", EntryPoint="ResumePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short ResumePrinterActivity();

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_Find", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Find();

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_Version", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Version(short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_Model", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Model(short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_MemSize", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_MemSize(short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_Count", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Count(short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_ReadData", CallingConvention = CallingConvention.StdCall)]
        public static extern short Dongle_ReadData(int UserCode, IntPtr Data, short Count, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_ReadDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_ReadDataEx(int UserCode, IntPtr data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_ReadSerNr", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_ReadSerNr(int UserCode, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_WriteData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteData(int UserCode, IntPtr Data, short Count, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_WriteDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteDataEx(int UserCode, IntPtr Data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_WriteKey", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteKey(int UserCode, IntPtr KeyData, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_GetKeyFlag", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_GetKeyFlag(int UserCode, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_Exit", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Exit();

		[DllImport("MATRIX32.DLL", EntryPoint="SetConfig_MatrixNet", CallingConvention = CallingConvention.StdCall)]
		public static extern short SetConfig_MatrixNet(short nAccess, string nFile);

		[DllImport("MATRIX32.DLL", EntryPoint="GetConfig_MatrixNet", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetConfig_MatrixNet(short Category);

		[DllImport("MATRIX32.DLL", EntryPoint="LogIn_MatrixNet", CallingConvention = CallingConvention.StdCall)]
		public static extern short LogIn_MatrixNet(int UserCode, short AppSlot, short DngNr);

		[DllImport("MATRIX32.DLL", EntryPoint="LogOut_MatrixNet", CallingConvention = CallingConvention.StdCall)]
		public static extern short LogOut_MatrixNet(int UserCode, short AppSlot, short DngNr);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_EncryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_EncryptData(int UserCode, IntPtr DataBlock, short DngNr, short Port);

		[DllImport("MATRIX32.DLL", EntryPoint="Dongle_DecryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_DecryptData(int UserCode, IntPtr DataBlock, short DngNr, short Port);
	}
}

