/*****************************************************************************/
/*  MATRIXDEMO.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                     */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Example for C#                                                           */
/*****************************************************************************/

using System;
using System.Windows.Forms; // MessageBox

namespace Demo
{
	/// <summary>
	/// Zusammenfassung fE matrixdemo.
	/// </summary>
	public class MatrixDemo
	{
		private short RetCode;
		private int[] DataIn;
		private int[] DataOut;
		private int[] KeyData;
		private int[] DataBlock;
		private short DNG_Count;
		private short DNG_Nummer;
		private short DNG_Mem;
		private short DNG_MaxVar;
		private int DNG_Version;
		private int DNG_SerNr;
		private short VerMajor;
		private short VerMinor;
		private short AppSlot;
        private short DNG_Port;

        // ***********************************************************
        // * In diesem Beispiel wird der Demo-UserCode 1234 und      *
        // * LPT-Port 1 verwendet.                                   *
        // * - Setzen Sie DNG_Port = 85, um den USB-Dongle zu testen *
        // ***********************************************************
        const short UserCode = 1234;

        Matrix.API mxapi =  new Matrix.API();

		public MatrixDemo()
		{
			DataIn = new int[256];
			DataOut = new int[256];
			KeyData = new int[4];
			DataBlock = new int[2];
		}


		public void SetActivePort(string Port)
		{
			DNG_Port = 0;
			switch(Port)
			{
				case "USB":
					DNG_Port = 85;
					break;
			}    
		}
	
		public void Number_of_Dongles()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Anzahl der Dongles an DNG_Port ermitteln                *
			// ***********************************************************
			DNG_Count = mxapi.Count();
		
			if(DNG_Count < 0)
                MessageBox.Show("CountG[: " + DNG_Count.ToString());
            else if (DNG_Count == 0)
                MessageBox.Show("hO܂!");
			else
				MessageBox.Show( DNG_Count.ToString() + "̃hO܂");
		
			RetCode = mxapi.Release();
		}
		public void Memory_of_Dongle()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Speichergre des letzten Dongles an DNG_Port lesen und *
			// * die maximale Anzahl der Datenfelder berechnen           *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_Mem = mxapi.MemSize(DNG_Nummer);
		
			if(DNG_Mem <= 0)
			{
				MessageBox.Show("MemSizeG[:" + DNG_Mem.ToString());
				return;
			}
		
			DNG_MaxVar = (short)(DNG_Mem / 4);
		
			MessageBox.Show("f[^tB[h: " + DNG_MaxVar.ToString());	
			
			RetCode = mxapi.Release();
		}
		
		public void Version_of_Dongle()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Die Versionsnummer des letzten Dongles an DNG_Port      *
			// * lesen                                                   *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_Version = mxapi.Version(DNG_Nummer);
		
			if(DNG_Version <= 0)
			{
				MessageBox.Show("VersionG[:" + DNG_Version.ToString());
			}
			else
			{
				VerMinor = (short)(DNG_Version & 0xffff);
				VerMajor = (short)(DNG_Version >> 16);
				MessageBox.Show("hÕo[W: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}

			RetCode = mxapi.Release();		
		}
	
		public void Read_Dongle_SerNr()
		{
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Seriennummer aus dem letzten Dongle an DNG_Port mit     *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			DNG_SerNr = mxapi.ReadSerNr(UserCode, DNG_Nummer);
		
			if(DNG_SerNr < 0)
			{
				MessageBox.Show("ReadSerG[: " + DNG_SerNr.ToString());
				RetCode = mxapi.Release();
				return;
			}
			MessageBox.Show("VAԍF (10i) " + DNG_SerNr.ToString() + "    (16i) " + DNG_SerNr.ToString("X"));
		
			RetCode = mxapi.Release();
		
		}
	
		public void Read_Dongle_Data()
		{
			string MessageString;
			short  i;
		
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * 3 Datenfelder aus dem letzten Dongle an DNG_Port mit    *
			// * dem UserCode lesen und anzeigen.                        *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();

          
           RetCode = mxapi.ReadData(UserCode, DataIn, (short)3, DNG_Nummer);
          

			if(RetCode < 0)
			{

				MessageBox.Show("ReadDataG[:" + RetCode.ToString());
				RetCode = mxapi.Release();
				return;
			}
		
			MessageString = "f[^tB[hǍ: \n\n";
			for(i = 0; i <= 2; i++)
			{
				MessageString = MessageString + "tB[h" + (i + 1).ToString("D4") + ":  " + DataIn[i].ToString() + "\n";
			}
			MessageBox.Show(MessageString);
		
			RetCode = mxapi.Release();
		
		}
	
		public void Write_Dongle_Data()
		{
			short  i;

			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * 3 Datenfelder im letzten Dongle an DNG_Port mit dem     *
			// * UserCode speichern.                                     *
			// * Als Beispiel werden die Werte 101,102,103 gespeichert.  *
			// ***********************************************************
			DNG_Nummer = mxapi.Count();
		
			for(i = 0; i <= 2; i++)
			{
				DataOut[i] = 101 + i;
			}

 
             RetCode = mxapi.WriteData(UserCode, DataOut, 3, DNG_Nummer);

		
			if(RetCode < 0)
				MessageBox.Show("WriteDataG[: " + RetCode.ToString() );
			else
				MessageBox.Show("ݐ");
		
			RetCode = mxapi.Release();		
		}	

		public void Dongle_Encrypt_Decrypt()
		{
			string MessageString;
		
			RetCode = mxapi.Init();
		
			DataBlock[0] = 1234567890; // Clear Data
			DataBlock[1] = 1234567890; // Clear Data
		
			MessageString = ":   \t" + "(10i)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(16i)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			DNG_Nummer = mxapi.Count();
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle verschlEseln                *
			// ***********************************************************
            RetCode = mxapi.EncryptData(UserCode, DataBlock, DNG_Nummer);

		
			if(RetCode < 0)
			{
				MessageBox.Show("G[F" + RetCode.ToString());
				RetCode = mxapi.Release();
				return;
			}
		
			MessageString = MessageString + "Íf[^: \t(10i)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(16i)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n";
		
			// ***********************************************************
			// * DatenBlock Eer den Dongle entschlEseln                *
			// ***********************************************************
            RetCode = mxapi.DecryptData(UserCode, DataBlock, DNG_Nummer);
		
			if(RetCode < 0)
			{
				MessageBox.Show("G[F" + RetCode.ToString());
				RetCode = mxapi.Release();
			}
		
			MessageBox.Show(MessageString + "f[^: \t(10i)  " + DataBlock[0].ToString() + "\t   " + DataBlock[1].ToString() + "\n\t\t(16i)  " + DataBlock[0].ToString("X") + "\t   " + DataBlock[1].ToString("X") + "\n\n");
	
			RetCode = mxapi.Release();
		}
	
		public void Version_of_API()
		{
			int RetVer;
		
			RetCode = mxapi.Init();
		
			// ***********************************************************
			// * Version der Matrix-API lesen und anzeigen               *
			// ***********************************************************
			RetVer = mxapi.VersionAPI();
		
			if(RetVer == 0)
				MessageBox.Show("VersioniAPIG[:" + RetVer.ToString());
			else
			{
				VerMinor = (short)(RetVer & 0xffff);
				VerMajor = (short)(RetVer >> 16);
				MessageBox.Show("Matrix-APIo[W: " + VerMajor.ToString() + "." + VerMinor.ToString());
			}		
		
			RetCode = mxapi.Release();
		
		}
	
		public void Dongle_Network()
		{

			// *************************************************************
			// * Netzwerk                                                  *
			// * Beispiel: In der Variable Var0002 des Dongles ist der     *
			// *           Wert 7 gespeichert.                             *
			// *           Das bedeutet: AppSlot2 = max. 7 Users           *
			// *************************************************************
		
			RetCode = mxapi.Init();
		
			// *************************************************************
			// * Maximale Anzahl der Users ist in AppSlot 2 (Var0002) des  *
			// * Dongles vermerkt.                                         *
			// *************************************************************
			AppSlot = 2;
		
			// *************************************************************
			// * Netzwerk Zugriff in der Matrix-API aktivieren             *
			// *************************************************************
			string MxNetFile;
			MxNetFile = "c:\\matrix\\test.svr";


			RetCode = mxapi.SetConfig(1, MxNetFile);
		
			// *************************************************************
			// * Anzahl der Netzwerk-Dongles ermitteln                     *
			// * !! DNG_Port wird ignoriert im Netzwerk-Modus !!           *
			// *************************************************************
			DNG_Nummer = mxapi.Count();
		
			// *************************************************************
			// * LogIn belegt einen User-Slot und leifert als REkgabewert *
			// * die Anzahl der noch freien User-Slots                     *
			// '* (In unserem Beispiel wird der RetCode=6 sein)             *
			// *************************************************************
			RetCode = mxapi.LogIn(UserCode, AppSlot, DNG_Nummer);
            if (RetCode < 0)
            {
                if (RetCode == -31)
                    MessageBox.Show("XbgCZX̏ɒBĂ܂");
                else
                    MessageBox.Show("OCG[: " + RetCode.ToString());
            }
            else
                MessageBox.Show("LogIn!  CZXc: " + RetCode.ToString());
		
			// *************************************************************
			// * LogOut gibt den User-Slot wieder frei und gibt zurEk die *
			// * Anzahl der noch freien User-Slots (in unserem Beispiel    *
			// * RetCode=7)                                                *
			// *************************************************************
			RetCode = mxapi.LogOut(UserCode, AppSlot, DNG_Nummer);
			if(RetCode < 0)
				MessageBox.Show("LogOutG[F" + RetCode.ToString());
			else
				MessageBox.Show("LogOut! CZXc: " + RetCode.ToString());

            // *************************************************************
            // * Netzwerk Zugriff in der Matrix-API deaktivieren           *
            // *************************************************************

            RetCode = mxapi.SetConfig(0, null);
		
			RetCode = mxapi.Release();
		
		}
	
		public void App_Encrypt()
		{
			string MessageString;
			uint[] Key = new uint[4];
			uint[] Data = new uint[2];
		
			Data[0] = 0x499602D2;   // dec: 1234567890
			Data[1] = 0x499602D2;   // dec: 1234567890
		
			Key[0] = 0x423A612E;    // dec: 1111122222
			Key[1] = 0x423A8C95;    // dec: 1111133333
			Key[2] = 0x8474C25C;    // dec: 2222244444
			Key[3] = 0x8474EDC3;    // dec: 2222255555
		
			MessageString = ":   \t(10i)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                          "\n\t\t(16i)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + 
			                          "\n\n" + 
			                "Í:          \t(10i)  " + Key[0].ToString() + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString() + 
			                          "\n\t\t(16i)  " + Key[0].ToString("X") + "\t      " + Key[1].ToString() + "\t  " + Key[2].ToString() + "\t" + Key[3].ToString("X") + "\n\n";

			MATRIX_ENCRYPT.MxCrypt.MxApp_Encrypt(Data, Key);
		
			// *** Display Data[0]/Data[1] as long ***
			MessageBox.Show(MessageString + "Íf[^: \t(10i)  " + Data[0].ToString() + "\t      " + Data[1].ToString() + 
			                                            "\n\t\t(16i)  " + Data[0].ToString("X") + "\t      " + Data[1].ToString("X") + "\n\n");
		}

	} // end class
} // end namespace

